var orm = require(__dirname + "/../lib/orm");

orm.connect("mysql://orm:orm@localhost/orm", function (success, db) {
	// define a Person
	var Person = db.define("a_person", { // this is to have 2 tables on db (because of other examples)
		"name"		: String,
		"surname"	: String,
		"male"		: Boolean
	}, {
		"methods"	: {
			// this is a method that can be called in any
			// instance
			"fullName" :function () {
				return this.name + " " + this.surname;
			}
		},
		"fetchDepth": 2
	});
	Person.hasOne("father", {
		"autoFetch": true
	});
	Person.hasOne("mother", {
		"autoFetch": true
	});
	Person.hasMany("brothers", {
		"autoFetch": true
	});

	// sync to database
	Person.sync();
	//Person.find({ name: "Haruki" }, function (person) {
	Person.get(8, function (person) {
		console.log(person);

		// setTimeout(function () {
		// 	console.log(person);
		// }, 1e3);
	});
	
	// create the Person John (if it does not exist)
	// createJohn(function (John) {
	// 	console.log(John);
	// 	// create the Pet Deco (if it does not exist)
	// 	createDeco(function (Deco) {
	// 		// add Deco has a pet from John
	// 		John.addPets(Deco, function () {
	// 			console.log(Deco.name + " is now " + John.fullName() + "'s dog");
	// 		});
	// 	});
	// });

	function createJohn(callback) {
		Person.find({ "name": "John" }, function (people) {
			if (people === null) {
				var John = new Person({ "name": "John", "surname": "Doe", "created": new Date(), "age": 25 });
				John.save(function (err, person) {
					callback(person);
				});
			} else {
				callback(people[0]);
			}
		});
	}

	function createDeco(callback) {
		Pet.find({ "name": "Deco" }, function (pets) {
			if (pets === null) {
				var Deco = new Pet({ "name": "Deco", "type": "dog" });
				Deco.save(function (err, dog) {
					callback(dog);
				});
			} else {
				callback(pets[0]);
			}
		});
	}
});
